package xib.description;

import com.ibm.xml.parser.*;
import org.w3c.dom.*;
import java.util.Vector;
import java.util.Enumeration;
import java.util.Date;
import java.util.StringTokenizer;
import java.util.Hashtable;
import xib.description.*;
import xib.util.*;
import xib.xmlUtil.*;
import javax.swing.*;

public class XIBDescription{
  Element inputDesc;
  Element outputDesc;
  Element inputBinding;
  Element outputBinding;
  
  private String anotation = "";
  private String serviceName = "";
  private String serviceDesc = "";
  private String outputName = "";
  private String script;
  private String outputRootTag="";
  private String strDoc = "";


	  //the "books" in <elementTyep id="books"> ...</elementType>

  /** construct a XIBDesscription from a xml string.
   **/
  public XIBDescription(String desc){
	try{
	  new XIBDescription(DomUtil.readDocumentFromString(desc));
	}catch (Exception e){
	}
  }  
  /** construc a XIBDescription from a xml Document.
   **/
  public XIBDescription(Document doc){
	if (doc ==null) Misc.message("Unexpected null XIB description Document.");
	NodeList nodes=null; 

	nodes=doc.getElementsByTagName("SERVICE");
	serviceName = ((Element)nodes.item(0)).getAttribute("name");

	Node n =doc.getElementsByTagName("DESCRIPTION").item(0);
	serviceDesc = DomUtil.toString(n);
	
	nodes=doc.getElementsByTagName("INPUT");
	inputDesc=(Element)((nodes==null)? null: nodes.item(0));
	
	nodes=doc.getElementsByTagName("OUTPUT");
	outputName = ((Element)nodes.item(0)).getAttribute("name");
	outputDesc=(Element)((nodes==null)?null:nodes.item(0));
	//Misc.message("OUTPUT=" + DomUtil.toString((Node)outputDesc));

	nodes=doc.getElementsByTagName("INPUTBINDING");
	inputBinding=(Element)((nodes==null)?null:nodes.item(0));
	
	nodes=doc.getElementsByTagName("OUTPUTBINDING");
	outputBinding=(Element)((nodes==null)?null: nodes.item(0));

	if (inputDesc==null)  
	  Misc.message("unexpected empty input description.");
	if (outputDesc==null) 
	  Misc.message("unexpected empty output description.");
	if (inputBinding==null) 
	  Misc.message("unexpected empty inputBinding description.");

	outputRootTag=outputDesc.getAttribute("name");
  }  
  /** construc a XIBDescription from a xml Document.
   **/
  public XIBDescription(Document doc, String stringDoc){

	strDoc = stringDoc;
	  
	if (doc ==null) Misc.message("Unexpected null XIB description Document.");
	NodeList nodes=null; 

	nodes=doc.getElementsByTagName("SERVICE");
	serviceName = ((Element)nodes.item(0)).getAttribute("name");
	
	nodes=doc.getElementsByTagName("INPUT");
	inputDesc=(Element)((nodes==null)? null: nodes.item(0));
	
	nodes=doc.getElementsByTagName("OUTPUT");
	outputDesc=(Element)((nodes==null)?null:nodes.item(0));
	//Misc.message("OUTPUT=" + DomUtil.toString((Node)outputDesc));

	nodes=doc.getElementsByTagName("INPUTBINDING");
	inputBinding=(Element)((nodes==null)?null:nodes.item(0));
	
	nodes=doc.getElementsByTagName("OUTPUTBINDING");
	outputBinding=(Element)((nodes==null)?null: nodes.item(0));

	if (inputDesc==null)  
	  Misc.message("unexpected empty input description.");
	if (outputDesc==null) 
	  Misc.message("unexpected empty output description.");
	if (inputBinding==null) 
	  Misc.message("unexpected empty inputBinding description.");

	outputRootTag=outputDesc.getAttribute("name");
  }  
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getBase() {
	
  return ((CharacterData)inputBinding.getElementsByTagName("BASE").item(0).getFirstChild()).getData();

}
  /** inputValue is of the form  
	  <XMP>
	  <inputValue>
		<query> XML programming </query>
		<mode> books </mode>
	  </inputValue>
	  </XMP>
	  from <CODE>inputValue</CODE>  construct the following:
	  <CODE>
	  "keyword-query"="xml tools", "mode"="books"
	  </CODE>
  **/
  public String getBindingString(Element inputValue){
	NodeList values = inputValue.getChildNodes();
	Hashtable table = new Hashtable();
	for (int i = 0; i<values.getLength(); i++){
	  Node value=values.item(i);
	  if (value instanceof Element){
	table.put(value.getNodeName().trim(), DomUtil.toString(value.getChildNodes()).trim());
	  }
	}
	String result="";
	NodeList bindings=inputBinding.getElementsByTagName("BINDING");
	for (int i = 0; i < bindings.getLength(); i++){
	  Element binding=(Element)bindings.item(i);
	  String variable = binding.getAttribute("variable").trim();
	  String mapsTo   = binding.getAttribute("mapsTo").trim();
	  String value    = (String)table.get(variable);
	  result = result+ "\"" + mapsTo + "\"=\"" + value + "\"";
	  if (i<bindings.getLength()-1) result = result + ",";
	}
	return result;
  }  
  /** 
	  from <CODE>inputValue</CODE>, 
	  construct the binding string like the following:
	  <CODE>
	  "keyword-query"="xml tools", "mode"="books"
	  </CODE>
  **/
 
  public String getBindingString(Input inputValue){
		String[] names=inputValue.getNames();
		String[] values=inputValue.getValues();
		Hashtable table = new Hashtable();
		for (int i = 0; i<values.length; i++){
		  //System.out.println("XIBDescription.java: name/value "+names[i]+"/"+values[i]);
		  //System.out.println("XIBD: names.l="+names.length+" values.l="+values.length);

		  table.put(names[i], values[i]);
		}

		String result="";
		NodeList bindings=inputBinding.getElementsByTagName("BINDING");
		for (int i = 0; i < bindings.getLength(); i++){
		  Element binding=(Element)bindings.item(i);
		  String variable = binding.getAttribute("variable").trim();
		  String mapsTo   = binding.getAttribute("mapsTo").trim();
		  String value    = (String)table.get(variable);
		  result = result+ "\"" + mapsTo + "\"=\"" + value + "\"";
		  if (i<bindings.getLength()-1) result = result + ",";
		}
		return result;
  }  
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getDBQuery() {

   return ((CharacterData)inputBinding.getElementsByTagName("DBQUERY").item(0).getFirstChild()).getData();
  
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getDriver() {
	
  return ((CharacterData)inputBinding.getElementsByTagName("DRIVER").item(0).getFirstChild()).getData();

  
}
  /*
  public String[] getVariables(){
	String tags=showTags(this.getTags(inputDesc))+
	  showTags(this.getTags(outputDesc));
	StringTokenizer st = new StringTokenizer(tags, "<>");
	String[] result = new  String[st.countTokens()];
	int i = 0;
	while (st.hasMoreTokens()){
	  result[i]=st.nextToken();
	  i++;
	}
	return result;
	  
  }
  */

  /** get the elements that have the specified name and value
	  from the elements that have the element type 'elementType'.
	  e.g. get 
	  <XMP> 
	  <elementType id="books">...</elementType>
	  </XMP>
	  provided the <CODE> name </CODE> 
	  and <CODE> value </CODE>  are <CODE > id</CODE> and <CODE> books</CODE>, 
	  repectively. 
  **/
  public Node getElementByAttrValue(String name, String value){
	NodeList nodes = outputDesc.getElementsByTagName("elementType");
	for (int i=0; i<nodes.getLength(); i++){
	  Node node=nodes.item(i);
	  if (((Element)node).getAttribute(name).equalsIgnoreCase(value)){
		return node;
	  }
	}
	return null;
  }  
/**
 * This method was created in VisualAge.
 * @return java.util.Vector
 */
public Vector getInputAttributesVec() {

	Vector result = new Vector();
	String[] temp = null;
	String tempStr;
	
	Set vars=new Set();
	NodeList inodes=inputDesc.getElementsByTagName("elementType");
	
	int size = inodes.getLength();
	int size2;


	for(int i = 0; i < size; i++){

	  result.addElement(new Vector());
		
	  Node variableElement = inodes.item(i);

	  if (! (variableElement instanceof Element)){
		Misc.message("Element expected in input description.");
	  } 
	  else if (((Element)variableElement).getElementsByTagName("attribute").getLength() ==0) {
	    continue;
	  }
	  else if (variableElement instanceof Element){
		temp = new String[2];
		
		NodeList optionElements= ((Element)variableElement).getElementsByTagName("attribute");
		Element optionElement=(Element)optionElements.item(0);

		if (optionElements.getLength() !=0){
		  temp[0] = optionElement.getAttribute("name");	
		  temp[1] = optionElement.getAttribute("values");
		}
	  }
	  ((Vector) result.elementAt(i)).addElement(temp);
	}

	return result;
	
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String[]
 */
public String[] getInputAttributeValues() {
	
  Vector attributes = getInputAttributesVec();
  Vector result = new Vector();
  StringTokenizer s;
  int size = attributes.size();
  Vector tmpVec;

  for(int i = 0; i < size; i++){

	tmpVec = (Vector) attributes.elementAt(i);

	if(tmpVec.size() == 0)
	  continue;

	//Add the attribute name to the result.
	result.addElement(((String[]) tmpVec.elementAt(0))[0]);
	  
	s = new StringTokenizer(((String[]) (tmpVec).elementAt(0))[1]);

	//Add all the attribute values to the result.
	while(s.hasMoreTokens())
	  result.addElement(s.nextToken());

  }

  size = result.size();
  String[] tmpArray = new String[size];

  for(int i = 0; i < size; i++)
	tmpArray[i] = (String) result.elementAt(i);

  return tmpArray;
  
}
/**
 * This method was created in VisualAge.
 * @return java.util.Vector
 */
public Vector getInputTypesVec() {

	Vector result = new Vector();
	String[] temp = null;
	String tempStr;
	
	Set vars=new Set();
	NodeList inodes=inputDesc.getElementsByTagName("elementType");
	
	int size = inodes.getLength();
	Node variableElement;


	for(int i = 0; i < size; i++){

	
	  variableElement = inodes.item(i);

	  if (! (variableElement instanceof Element)){
		Misc.message("Element expected in output description.");
		return null;
	  } 
	  else if (((Element)variableElement).getElementsByTagName("element").getLength() ==0) {
		result.addElement(null);
	    continue;
	  }
	  else{

		NodeList types = ((Element)variableElement).getElementsByTagName("element");

		temp = new String[2];
		temp[0] = ((Element) types.item(0)).getAttribute("type");
   	    temp[1] = ((Element) types.item(0)).getAttribute("occurs");
		  
  	    result.addElement(temp);

	  }
	}

	return result;
	
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String[]
 */
public String[] getInputVars() {

	Set vars=new Set();
	NodeList inodes=inputDesc.getElementsByTagName("elementType");
	for (int i = 0; i<inodes.getLength(); i++) {
	  vars.add(((Element)inodes.item(i)).getAttribute("id"));
	}

	int k = vars.size();
	
	if (vars==null) Misc.message("unexpected null variables.");

	Enumeration els = vars.elements();
	String[] result = new String[vars.size()];

	int i = 0;
	while (els.hasMoreElements()){
	  result[i]=(String)els.nextElement();
	  i++;
	}

	return result;
	
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String[]
 */
public String[] getMapping() {

  NodeList bindings = inputBinding.getElementsByTagName("BINDING");
  int size = bindings.getLength();
  Node variableElement;

  String[] result = new String[size];

  
  for(int i = 0; i < size; i++){
	variableElement = bindings.item(i);
	result[i] = ((Element)variableElement).getAttribute("mapsTo");
  }
	
  return result;
}
  /** Get the POST or GET method in inputBinding.
   **/
  public String getMethod(){
	Element base = (Element)(inputBinding.getElementsByTagName("BASE").item(0));
	return base.getAttribute("method");
  }  
  /** get the name of the information source.
   **/
  public String getName(){
	return serviceName;
  }  
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getOutputName() {
	return outputName;
}
  /** Get the nesting  of tag names of the output description.
	  e.g., a vector of 
	  <CODE> <author(firstName, lastName), title, year> .
	  </CODE>
	  A vector is used to store arbitrary nesting of the tags.
	  <XMP>
		 rootTag ="books", root =
		 <elementType id="books">
		 <element type="#book" occurs="ZEROORMORE" />
		 </elementType>
	  </XMP>
   **/
  public Vector getOutputTags(){  
	Node root=this.getElementByAttrValue("id", outputRootTag);
	Vector result=this.getTags((Element)root);
	//Misc.message("outputTags "+showTags(result));
	return result;

  }  
/**
 * This method was created in VisualAge.
 * @return java.util.Vector
 */
public Vector getOutputTypesVec() {

	Vector result = new Vector();
	String[] temp = null;
	String tempStr;
	
	Set vars=new Set();
	NodeList inodes=outputDesc.getElementsByTagName("elementType");
	
	int size = inodes.getLength();
	int size2;


	for(int i = 0; i < size; i++){

	  result.addElement(new Vector());
		
	  Node variableElement = inodes.item(i);

	  if (! (variableElement instanceof Element)){
		Misc.message("Element expected in output description.");
		return null;
	  } 
	  else if (((Element)variableElement).getElementsByTagName("element").getLength() ==0) {
	    continue;
	  }
	  else if (variableElement instanceof Element){

		NodeList types = ((Element)variableElement).getElementsByTagName("element");
		int size3 = types.getLength();

		for(int a = 0; a < size3; a++){
		  
		  temp = new String[2];
		  temp[0] = ((Element) types.item(a)).getAttribute("type");

		  tempStr = ((Element) types.item(a)).getAttribute("occurs");;


		  if (tempStr != null)
		    temp[1] = tempStr;
		  else
		    temp[1] = "";

		  
		  ((Vector) result.elementAt(i)).addElement(temp);
	    }
	  }
	}

	return result;
	
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String[]
 */
public String[] getOutputVars() {

	Set vars=new Set();
	NodeList inodes=outputDesc.getElementsByTagName("elementType");
	for (int i = 0; i<inodes.getLength(); i++) {
	  vars.add(((Element)inodes.item(i)).getAttribute("id"));
	}
	
	if (vars==null) Misc.message("unexpected null variables.");

	Enumeration els = vars.elements();
	String[] result = new String[vars.size()];

	int i = 0;
	while (els.hasMoreElements()){ 
	  result[i]=(String)els.nextElement();
	  i++;
	}

	return result;
	
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getPage() {

	 Element base = (Element)(inputBinding.getElementsByTagName("BASE").item(0));
	 String temp = Misc.deNormalize(base.getAttribute("page"));
	 int i = temp.indexOf('"');
	 String result = temp.substring(0, i);
	 result += "&quot;";
	 int j = temp.lastIndexOf('"');
	 result += temp.substring(i + 1, j) + "&quot;" + temp.substring(j+1, temp.length());

	 return result;
	
}
  public String getPageValue(){
	  
	 Element base = (Element)(inputBinding.getElementsByTagName("BASE").item(0));
	 return Misc.deNormalize(base.getAttribute("page"));
  }  
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getPassword() {
	
  return ((CharacterData)inputBinding.getElementsByTagName("PASSWORD").item(0).getFirstChild()).getData();

  
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getScript() {
	return DomUtil.toString(outputBinding.getElementsByTagName("SCRIPT").item(0).getChildNodes().item(1));
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getServiceDesc() {

	int i = (new String("<DESCRIPTION> ")).length();
	int j = serviceDesc.indexOf("\n  </DESCRIPTION>");
	
	return serviceDesc.substring(i, j);
}
  /** get all the attribute values that have the form
	  <CODE>
	  <element type ="#author"> ....</elementType>,
	  </CODE>
	  recursively.
	  the result tags 
	  <CODE>
	  <books> <<book> <author year title>>
	  </CODE>
  **/
  public Vector getTags(Element elem){
	if (elem==null) return null;
	Vector result = new Vector();
  
	if (elem.getNodeName().equalsIgnoreCase("elementType")){
	  String nonLeafTag=(String)elem.getAttribute("id");
	  Vector v=new Vector();
	  v.addElement(nonLeafTag);
	  result.addElement(v);
	} else Misc.message("invalid output description: elementType expected.");
	
	NodeList children = elem.getChildNodes();
	Vector childTags=new Vector();
	for (int i=0; i<children.getLength(); i++){
	  Node node = children.item(i);
	  if (node instanceof Element){
	String tag = node.getNodeName();
	if(tag.equalsIgnoreCase("elementType")){
	}else if (tag.equalsIgnoreCase("element")){
	  String tagName = ((Element)node).getAttribute("type");
	  if (this.isLeaf(tagName)){
	    //Misc.message("leaf ! "+ tagName);
	    childTags.addElement(tagName);
	  }else {
	    Node root = getElementByAttrValue("id",tagName);
	    Vector innerTags=this.getTags((Element)root);
	    if (innerTags!=null) childTags.addElement(innerTags);
	  }
	}
	  }	
	
	}   
	if (childTags!=null) result.addElement(childTags);
	  
	return result;
  }  
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getURL() {
	
  String temp = ((CharacterData)inputBinding.getElementsByTagName("BASE").item(0).getFirstChild()).getData();

  int i = temp.indexOf('\"');
  int j = temp.lastIndexOf('\"');
  
  return temp.substring(i + 1, j);
  
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getUser() {
	
  return ((CharacterData)inputBinding.getElementsByTagName("USER").item(0).getFirstChild()).getData();
  
}
  /** Get both the names of both input and output 
	  variables of the description. 
  **/

  public String[] getVariables(){
	Set vars=new Set();
	NodeList inodes=inputDesc.getElementsByTagName("elementType");
	for (int i = 0; i<inodes.getLength(); i++) {
	  vars.add(((Element)inodes.item(i)).getAttribute("id"));
	}
	
	NodeList onodes=outputDesc.getElementsByTagName("elementType");
	for (int i = 0; i<onodes.getLength(); i++) {
	  vars.add(((Element)onodes.item(i)).getAttribute("id"));
	}
	
	if (vars==null) Misc.message("unexpected null variables.");

	Enumeration els = vars.elements();
	String[] result = new String[vars.size()];

	int i = 0;
	while (els.hasMoreElements()){ 
	  result[i]=(String)els.nextElement();
	  i++;
	}

	return result;
	
  }  
  /** get the vectors inside a vector.
   **/
  public static Vector getVectors(Vector tags){
	Vector result = new Vector();   
	if (tags==null) return null;
	Enumeration items = tags.elements();
	while ( items.hasMoreElements()){
	  Object item=items.nextElement();
	  if (item instanceof Vector){
	result.addElement((Vector)item);
	  }
	}      
	return result;
  }  
  public boolean hasPage(){
	Element base = (Element)(inputBinding.getElementsByTagName("BASE").item(0));
	return base.getAttribute("page")!=null;
  }  
/**
 * Method:  isInputAttrName
 * Purpose:  Return true if this is a name of an attribute.
 */
public boolean isInputAttrName(String id) {

  Vector attrVec = getInputAttributesVec();
  Vector tmpVec;
  int size = attrVec.size();
  int size2;

  for(int i = 0; i < size; i++){

	tmpVec = (Vector) attrVec.elementAt(i);
	size2 = tmpVec.size();
	  
	for(int j = 0; j < size2; j++){

	  if(((String[]) tmpVec.elementAt(j))[0].equals(id))
		return true;

	}
  }
  
  return false;
}
/**
 * This method was created in VisualAge.
 * @return boolean
 * @param id java.lang.String
 */
public boolean isInputAttrValue(String id) {

  return ((! isInputElementType(id)) && (! isInputAttrName(id)));
}
/**
 * Method:  isInputElementType
 * Purpose:  Given an id, return true if this document contains an input 
 *           elementType with that name.
 */
public boolean isInputElementType(String id) {

  String[] names = getInputVars();
  int size = names.length;

  for(int i = 0; i < size; i++){
	if(names[i].equals(id))
	  return true;
  }
	
  return false;
}
  /**  Test whether a tag name in this XIBDescription is a leaf or not. 
	  For example, in 
	  <XMP>
	   <element type="title" /> ,
	   <elementType id="title"> </string> </elementType>
	  </XMP>
	   "title" is a leaf tag name, i.e., no other elementTypes defined 
	   under this node. 
   **/
  private boolean isLeaf(String tag){
	if (this==null) Misc.message("XIBDescription.java: unexpected null XIBDescription in leaf test.");
	boolean result=false;
	Node elementType = this.getElementByAttrValue("id", tag);
	if (elementType == null) Misc.message("Tag "+ tag + " has no reference in XIB description.");
	//Misc.message("Leaf? "+ DomUtil.toString(elementType));
	NodeList nodes=elementType.getChildNodes();
	Node childElement=nodes.item(1);  
	//note it is item(1) instead of item(0).
	//before or after the Element node there are Text Nodes. 
	if (childElement instanceof Element) {
	  result = ((Element)childElement).getTagName().equalsIgnoreCase("String");
	} else {
	  Misc.message("Element expected.");
	}
	return result;
  }  
/**
 * This method was created in VisualAge.
 * @return boolean
 */
public boolean isWebSiteDesc() {

  String temp = getBase();
	
  if(temp.indexOf("http") != -1)
	return true;
  else
	return false;
   
	
}
  private static String showTags(Vector v){
	String result="<";
	if (v==null) return "";
	Vector tags=(Vector)v.clone();
	Enumeration items = tags.elements();
	int i=0;
	while (items.hasMoreElements()){
	  Object item = items.nextElement();
	  if (item instanceof Vector){
	result=result + showTags((Vector)item);
	i++;
	  }else if (item instanceof String){
	result=result+ " " + (String)item;
	  }else Misc.message("tags vector exception");
	}
	return result+">";
  }  
/**
 * Method toInputDTD
 * Purpose:  Returns a string representing the input DTD for this document.
 */
public String toInputDTD() {

  //Get the names and attributes.
  String[] names = getInputVars();
  Vector attributes = getInputAttributesVec();

  String result = "";
  String tmpStr;
  Vector tmpList;
  int index;
  
  int numElements = names.length;

  for(int i = 0; i < numElements; i++){

	tmpList = (Vector) attributes.elementAt(i);

	if(tmpList.size() == 0)
	  result += "  <!ELEMENT " + names[i] + "  (#PCDATA)>\n";
	else{

	  tmpStr = (((String[]) tmpList.elementAt(0))[1]).replace(' ', '|');
	  index = tmpStr.indexOf('|');

	  if(index == -1)

	    index = tmpStr.length();
	    result += "  <!ELEMENT " + names[i] + "  EMPTY>\n";
	    result += "  <!ATTLIST " + names[i] + " " + ((String[]) tmpList.elementAt(0))[0] + " (" + tmpStr + ") \"" + tmpStr.substring(0, index) + "\">\n";

	}
  }
	
  return result;
}
/**
 * Method toOutputDTD
 * Purpose:  Returns a string representing the output DTD for this document.
 */
 
public String toOutputDTD() {

  String[] names = getOutputVars();
  Vector elements = getOutputTypesVec();

  String result = "";
  String tmpStr;
  Vector tmpList;
  int index;
  int size;
  
  int numElements = names.length;

  for(int i = 0; i < numElements; i++){

	tmpList = (Vector) elements.elementAt(i);

	if(tmpList.size() == 0)
	  result += "  <!ELEMENT " + names[i] + "  (#PCDATA)>\n";
	else{

	  size = tmpList.size();
	  tmpStr = "";

	  for(int j = 0; j < size; j++){

		tmpStr += ((String[]) tmpList.elementAt(j))[0];

		if(j != size -1)
		  tmpStr += ", ";

	  }

	  if(size == 1){
		result += "  <!ELEMENT " + names[i] + " " + tmpStr;

		if(((String[]) tmpList.elementAt(0))[1].equals("ZEROORMORE"))
		  result += "*>\n";
		else if(((String[]) tmpList.elementAt(0))[1].equals("ONEORMORE"))
		  result += "+>\n";
		else
		  result += ">\n";
	  }
	  else
	    result += "  <!ELEMENT " + names[i] + " (" + tmpStr + ")>\n";

	}
  }
	
  return result;  

}
  /** get the XML text representation. **/
  public String toString(){
	return serviceName + "\n" + DomUtil.toString(inputDesc) +"\n"+
	  DomUtil.toString(outputDesc);
  }  
  /** get the XML text representation. **/
  public String toStringFull(){
	return strDoc;
  }  
  /** get the tree representation of the description.
   **/
  public JTree toTree(){
	JTree result=null;
	return result;
  }  
 /** transform xib description and the input from html form to webl scripts. 
	  input is an XML document specifies the value for each control in the html form. 
	  e.g.,<CODE> <title> XML </title>  </CODE>
	  specifies that the html control 'title' has the value 'XML'.
   **/
  public String toWebl(Element inputValue){
	
	String webl="// WebL script generated by XIB.\n";
	Date date = new Date();
	webl= webl + "// --" + date.toString() + "\n";   

	webl = webl + "import Str; \n";

	//Misc.message("Webl=\n" + webl);
	
	//the webl script that gets the html page 
	
	boolean GET=false; 
	boolean POST=false;
	String getPage="\n//script to get the html page.\n";
	String bindings="[.";
	if (this.getMethod().equalsIgnoreCase("POST")) { POST=true;
	} else GET=true;

	String BASE= ((CharacterData)inputBinding.getElementsByTagName("BASE").item(0).getFirstChild()).getData();
	if (this.hasPage()){
	  getPage=getPage+ "var P = GetURL(" + BASE + ");\n";
	  getPage=getPage+ "var form ="+ this.getPageValue() + ";\n"; 
	  getPage=getPage+ "P = PostURL(form.action, [. " + this.getBindingString(inputValue)+ " .]);\n";
	} else {
	  String binding = "[." + ".]";   
	  if (GET) {getPage=getPage+"var P = getURL("  + BASE + "," + binding + ");" + "\n";
	  } else if (POST) {
	getPage=getPage + "var P = PostURL("  + BASE + "," + binding + ");" + "\n";
	  }	else Misc.message("something wrong in METHOD.");
	}

	webl = webl + getPage;
	
   
	//Extract the result from the html page. Result is stored in var R.
	String getResult = "\n//script to extract the relevant result from a html page.\n";
	getResult=getResult + "var R =[]; \n var i=0; \n";
	Node scriptNode=outputBinding.getElementsByTagName("SCRIPT").item(0).getChildNodes().item(1);
	getResult = getResult + DomUtil.toString(scriptNode) + "\n";
	webl = webl + getResult;
   
	//Misc.message("getResult= \n " + getResult);

	//produce the XML output generation scripts.
	String XMLout="\n//Script to produce the XML document.\n";
	XMLout = XMLout + "  PrintLn( \"<"+ this.getName() + ">\");\n";
	XMLout = XMLout + "  PrintLn( \"<" + outputRootTag + ">\");\n";
	XMLout = XMLout + toXMLWebl(this.getOutputTags()) + "end;\n";
	XMLout = XMLout + "  PrintLn(\"</" + outputRootTag + ">\");\n"; 
	XMLout = XMLout + "  PrintLn(\"</" + this.getName() + ">\");\n"; 
	
	webl = webl + XMLout;
	return webl;
  }  
 /** transform xib description and the input from html form to webl scripts. 
	  input is an XML document specifies the value for each control in the html form. 
	  e.g.,<CODE> <title> XML </title>  </CODE>
	  specifies that the html control 'title' has the value 'XML'.
   **/
  public String toWebl(Input inputValue){
	
	String webl="// WebL script generated by XIB.\n";
	Date date = new Date();
	webl= webl + "// --" + date.toString() + "\n";   
	
	webl = webl + "import Str; \n";

	
	//the webl script that gets the html page 
	
	boolean GET=false; 
	boolean POST=false;
	String getPage="\n//script to get the html page.\n";
	String bindings="[.";
	if (this.getMethod().equalsIgnoreCase("POST")) { POST=true;
	} else GET=true;

	String BASE= ((CharacterData)inputBinding.getElementsByTagName("BASE").item(0).getFirstChild()).getData();
	if (this.hasPage()){
	  getPage=getPage+ "var P = GetURL(" + BASE + ");\n\n";
	  getPage=getPage+ "var form ="+ this.getPageValue() + ";\n";
	}
	  
   
	if (GET){
	  getPage=getPage+ "P = GetURL(form.action, [. " + this.getBindingString(inputValue)+ " .]);\n";
	}
	else if (POST) {
	  getPage=getPage+ "P = PostURL(form.action, [. " + this.getBindingString(inputValue)+ " .]);\n";
	}
	else Misc.message("something wrong in METHOD.");

	webl = webl + getPage;
	
   
	//Extract the result from the html page. Result is stored in var R.
	String getResult = "\n//script to extract the relevant result from a html page.\n";
	getResult=getResult + "var R =[]; \n var i=0; \n";
	Node scriptNode=outputBinding.getElementsByTagName("SCRIPT").item(0).getChildNodes().item(1);
	getResult = getResult + DomUtil.toString(scriptNode) + "\n";
	webl = webl + getResult;
   
	//Misc.message("getResult= \n " + getResult);

	//produce the XML output generation scripts.
	String XMLout="\n//Script to produce the XML document.\n";

	XMLout = XMLout + "  PrintLn( \"<"+this.getName()+">\");\n";
	XMLout = XMLout + "  PrintLn( \"<" + outputRootTag + ">\");\n";
	XMLout = XMLout + toXMLWebl(this.getOutputTags()) + "end;\n";
	XMLout = XMLout + "  PrintLn(\"</" + outputRootTag + ">\");\n"; 
	XMLout = XMLout + "  PrintLn(\"</"+this.getName()+">\");\n"; 
	
	webl = webl + XMLout;
	
	return webl;
  }        
  /** Generate the webl scripts that produces the XML output, based on
	  the output tags. this is a simplified version of implementation,
	  the output tags can only have 
	  a simple nesting like 
	  <XMP>
	  < <books> < 
				  < <book>
					<auth title year>
		  >
	        >
	  > 

	  or 
	  <<conversion><from into amount convertedAmount>>
	  </XMP>
	  are considered. 
  **/
  public static String toXMLWebl(Vector tags){
	if (tags==null) return "";
	
	//Misc.message("XIBDescription.java: tags ="+showTags(tags));
	String result="";
	String sndTag="";
	Vector leafTags=null;

	String topTag = (String)((Vector)tags.firstElement()).firstElement(); 
	Object snd    = ((Vector)tags.elementAt(1)).firstElement();
	if (snd instanceof Vector) {
	  sndTag = (String)((Vector)((Vector)snd).firstElement()).firstElement();
	  leafTags = (Vector)((Vector)snd).elementAt(1);
	}else if(snd instanceof String) {
	  leafTags=(Vector)tags.elementAt(1);
	}else Misc.message("unexpected  second level output tags ");
	
	String outputElements="";
	Enumeration items = leafTags.elements();
	while(items.hasMoreElements()){
	  String leafTag= (String)(items.nextElement());
	  outputElements=
	outputElements + "  PrintLn(\"<" + leafTag + ">\"," + "r." + leafTag + ", \"</" + leafTag + ">\");\n";
	  
	}			 
	 
	result=result + 
	   "every r in R do \n"
	  + "    PrintLn(\"<" + sndTag + ">\");\n"
	  + outputElements;

	result = result + "  PrintLn(\"</" + sndTag + ">\");\n"; 
	
	return result;
  }  
}